import {debugLogger as log} from '../logger/log';

var ProductsToShareDialog = (function () {
    function registerProductShareOnClickHandler(element,subject,body,mobilePlatform) {
        // Use unescape when possible.
        // decodeURIComponent has problems with chars like %.
        if(typeof unescape === "function"){
            subject = unescape(subject);
            body = unescape(body);
        } else {
            subject = decodeURIComponent(subject);
            body = body;
        }
        mobilePlatform = mobilePlatform;

        $(element).on("click", function (e) {
            log.debug("share start");
            e.preventDefault();
            var options = {
                chooserTitle: "Bitte wählen Sie eine App zum Teilen des Links"
            };
            if($(this).hasClass("sendList")){
                if(mobilePlatform=="ios"){
                    options.subject = subject;
                    options.message = body;
                } else {
                    options.subject = subject;
                    options.message = body;
                }
            } else {
                if(mobilePlatform=="ios"){
                    options.subject = subject;
                    options.message = "Entdeckt bei Cyberport: "+subject+" "+body;
                } else {
                    options.subject = " ";
                    options.message = "Entdeckt bei Cyberport: "+subject+" "+body;
                }
            }
            log.debug("share options:"+JSON.stringify(options));
            openNativeShareDialog(options);
        });
    }

    function buildDeeplink(incomingUrl,selectedShop,mobilePlatform,senderLoginStatus) {
        var url = incomingUrl+ "&wt_cc2=mobile_sharing-" + mobilePlatform + "-" + senderLoginStatus;
        if (selectedShop) {
            if (selectedShop === "de") {
                url = url.replace(".at", ".de");
            } else {
                url = url.replace(".de", ".at");
            }
        } else {
            if (window.location.host.indexOf(".at") !== -1) {
                url = url.replace(".de", ".at");
            }
        }
        var subdomains = ["aem-qa.", "aem-app-qa.","aem-stg.","aem-app-stg.","aem-uat.","aem-app-uat.","app."];
        for(var subPosition = 0; subPosition<subdomains.length;subPosition++){
            url = url.replace(subdomains[subPosition],"");
        }
        return url;
    }
    var onSuccess = function(result) {
        log.debug("SHARE PROCESSING: social sharing onSuccess msg: "+result);
    };

    var onError = function(msg) {
        log.debug("SHARE PROCESSING: social sharing onError msg: "+msg);
    };

    function openNativeShareDialog (options){
        window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
    }
    // ++++++++++++++++++++++++++++++++ Public methods ++++++++++++++++++++++++++++++++
    return {
        initForProductSharing: function (selectedShop, mobilePlatform, senderLoginStatus) {
            var mailtoLinksAsList = $('a[href^="mailto:"]');
            for(var i = 0; i<mailtoLinksAsList.length;i++){
                var mailtoLink = mailtoLinksAsList[i].href;
                if(mailtoLink.search("https")>0){

                    // get positions
                    var subjectStartPosition = mailtoLink.indexOf("subject=")+8;
                    var bodyStartPosition = mailtoLink.indexOf("&body=")+6;

                    // get subject
                    var subject = mailtoLink.slice(subjectStartPosition, bodyStartPosition-6);

                    // get url from body
                    var body = mailtoLink.slice(bodyStartPosition, mailtoLink.length);

                    var reg = new RegExp('(https[^\"]+)');
                    var matchedUrls = body.match(reg);

                    // add track parameter
                    if(matchedUrls){
                        var oldUrlWithoutTracking = matchedUrls[0];
                        var newUrlWithTracking = buildDeeplink(oldUrlWithoutTracking,selectedShop,mobilePlatform,senderLoginStatus);
                        if(newUrlWithTracking){
                            body = body.replace(oldUrlWithoutTracking, newUrlWithTracking);
                            registerProductShareOnClickHandler(mailtoLinksAsList[i],subject,body,mobilePlatform);
                        } else {
                            onError("SHARE PROCESSING: ERROR: newUrlWithTracking empty");
                        }

                    } else {
                        onError("SHARE PROCESSING: ERROR: No matches found");
                    }
                }
            }
        },
        _registerProductShareOnClickHandler : registerProductShareOnClickHandler,
        _buildDeeplink : buildDeeplink,
        _openNativeShareDialog : openNativeShareDialog
    };
})();
export {ProductsToShareDialog};
